#pragma once

namespace ruche {
namespace aviutl {
namespace plugins
{
    // YUY2̊eR|[lg̃XP[O^Cv\񋓒lB
    public enum class Yuy2ScaleType
    {
        // tWB Y, U, V  0 ` 255 B
        Full = 0,

        // ITU-R BT.601/BT.709 KYCbCrWB
        // Y  16 ` 235 A U, V  16 ` 240 B
        Compressed,
    };

    // YUY2̐Fݒ^Cv\񋓒lB
    public enum class Yuy2ColorMatrixType
    {
        // Bc720pxȂBT.601A720pxȏȂBT.709B
        Auto = 0,

        // BT.601BSD掿pB
        BT601,

        // BT.709BHD掿pB
        BT709,
    };

    // Yuy2ColorMatrixType  Auto ȊO̒lɌ肷B
    // yuy2ColorMatrix : ̒lB
    // mediaHeight : fBAf̏csNZBΒlpB
    inline Yuy2ColorMatrixType DecideYuy2ColorMatrixType(
        Yuy2ColorMatrixType yuy2ColorMatrix,
        long mediaHeight)
    {
        return (
            (yuy2ColorMatrix == Yuy2ColorMatrixType::Auto) ?
                ((mediaHeight < 720 && mediaHeight > -720) ?
                    Yuy2ColorMatrixType::BT601 :
                    Yuy2ColorMatrixType::BT709) :
                yuy2ColorMatrix);
    }
}
}}
